﻿#Region "-- Imports --"
Imports System.ComponentModel
Imports System.Globalization
Imports System.Globalization.CultureInfo
Imports System.Runtime.CompilerServices
#End Region

Public Module Module1

  <Extension()> _
  Public Function AtTime(ByVal [date] As DateTime, ByVal targetTime As String) As DateTime
    Dim result As DateTime = [date]
    Try
      If String.IsNullOrEmpty(targetTime) Then Throw New ArgumentNullException("A valid target time must be provided")
      Dim newTime As String = String.Format("{0} {1}", [date].ToString("dd MMMM yyyy"), targetTime)
      If IsDate(newTime) Then
        result = CDate(newTime)
      Else
        Throw New Exception(String.Format("The date and time provided do not evaluate to a valid date ( {0} )", newTime))
      End If
    Catch ex As Exception
      Throw New Exception(String.Format("{0}.AtTime Error", "DateExtenders"), ex)
    End Try
    Return result
  End Function


End Module
